﻿import es
import langlib
import playerlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2010/language/"

addon = es.import_addon("soccer_mod_2010/admin/settings")

settings_on = ["public", "show_votes", "sounds"]
settings = ["length", "delay", "percentage_start_match", "percentage_stop_match", "percentage_start_cap"]

# ******************** Load ********************
def load():
	for item in settings_on:
		es.set("sm_vote_%s_on" % (item), int(es.keygetvalue("soccer_mod_settings", "vote", item)))

	for item in settings:
		es.set("sm_vote_%s" % (item), int(es.keygetvalue("soccer_mod_settings", "vote", item)))

	create_popup()

	es.addons.registerSayFilter(filter)

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings(lang_dir + "popup_common.ini")
	texts = langlib.Strings(lang_dir + "admin/settings/popup_admin_settings_vote.ini")

	popup = popuplib.create("sm_popup_admin_settings_vote")

	popup.addline("SOCCER MOD %s" % (texts("title")))
	popup.addline(" ")

	for i in range(0, len(settings_on)):
		if es.ServerVar("sm_vote_%s_on" % (settings_on[i])) == 1:
			value = common("on")
		else:
			value = common("off")
		popup.addline("->%s. %s: %s" % (i + 1, texts(settings_on[i]), value))
		popup.select(i + 1, change_setting)

	for i in range(0, len(settings)):
		popup.addline("->%s. %s: %s" % (i + 4, texts(settings[i]), es.ServerVar("sm_vote_%s" % (settings[i]))))
		popup.select(i + 4, change_setting)

	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.submenu(9, "sm_popup_admin_settings")

# ******************** Popup choice ********************
def change_setting(userid, choice, popupid):
	if choice < 4:
		addon.set_boolean(userid, "vote", "vote", settings_on[choice - 1], popupid, choice)
	else:
		messages = langlib.Strings(lang_dir + "admin/settings/messages_settings_vote.ini")

		tokens = {}
		player = playerlib.getPlayer(userid)

		if es.exists("key", "sm_keygroup_set", player.steamid) == 0:
			es.keycreate("sm_keygroup_set", player.steamid)

		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_vote_%s" % (settings[choice - 4]))

		es.tell(userid, "#green", messages("type_%s" % (settings[choice - 4]), tokens, player.get("lang")))

# ******************** Events ********************
def filter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)
	if es.exists("key", "sm_keygroup_set", steamid) == 1:
		name = "sm_popup_admin_settings_vote"

		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "settings_vote_length":
			addon.set_number(userid, text, "vote", "vote", "length", 0, 1, 100, name, 4)
			return (0, None, 0)
		elif type == "settings_vote_delay":
			addon.set_number(userid, text, "vote", "vote", "delay", 0, 1, 100, name, 5)
			return (0, None, 0)
		elif type == "settings_vote_percentage_start_match":
			addon.set_number(userid, text, "vote", "vote", "percentage_start_match", 0, 0, 100, name, 6)
			return (0, None, 0)
		elif type == "settings_vote_percentage_stop_match":
			addon.set_number(userid, text, "vote", "vote", "percentage_stop_match", 0, 0, 100, name, 7)
			return (0, None, 0)
		elif type == "settings_vote_percentage_start_cap":
			addon.set_number(userid, text, "vote", "vote", "percentage_start_cap", 0, 0, 100, name, 8)
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_settings_vote")

	es.addons.unregisterSayFilter(filter)